*************************************
**  Recover Update program         **
**  NS/NSJ/NSH Ver.8.2  2009-02-02 **
*************************************

if(exist("/h0/OS9/SYS/myhello5_15")==TRUE)
	* NOTE: myhello5_15 is compatible for not only NS15 but any type of NS
	load -d /h0/OS9/SYS/myhello5_15
endif

load -d /h0/OS9/SYS/gzload

maui_inp&
setenv SHELL mshell
led_ctrl 2 0
led_ctrl 1 1

copy /h0/os9/sys/download
copy /h0/os9/sys/sysDL.bat
copy /h0/os9/sys/sysDL3.bat
copy /h0/os9/sys/led_Y_blk

load -d /h0/os9/sys/nstype
let nsval = execute("nstype")
let NS5  = ( (%nsval == -4) || (%nsval == -5) )
let NS8  = (%nsval == -3)
let NS10 = (%nsval == -1)
let NS12 = (%nsval ==  0)
let NS15 = (%nsval == -10)

let NS5x32 = (%nsval == -4)
let NS5x64 = (%nsval == -5)

if ( %NS5 )
	**** NS5 ****
	load -d /h0/os9/sys/gx_sed2
	load -d /h0/os9/sys/sctouch_5
	load -d /h0/os9/sys/tp0_5
	load -d /h0/os9/sys/maui_5
	load -d /h0/os9/sys/cdb_5
	load -d /h0/os9/sys/scscish4_5
	load -d /h0/os9/sys/term_5

elif ( %NS12 )
	**** NS12 ****
	load -d /h0/os9/sys/sctouch_12
	load -d /h0/os9/sys/tp0_12

elif ( %NS10 )
	**** NS10 ****
	load -d /h0/os9/sys/sctouch_10
	load -d /h0/os9/sys/tp0_10
	
elif ( %NS8 )
	**** NS8 ****
	load -d /h0/os9/sys/sctouch_8
	load -d /h0/os9/sys/tp0_8
elif ( %NS15 )
	**** NS15 ****
	load -d=/h0/os9/sys/  sctouch_15  tp0_15  mp_touch_analog_tp  gx_orchid
else
	****** sorry, LED only
	led_ctrl 2 0
	led_ctrl 0 1
	sleep 0
endif

***** Check PT type *****
load -d /h0/os9/sys/pttype
let ptval=execute("pttype")

***** Touch Panel test *****
load -d /h0/os9/sys/selfHWchk

let r_tp=execute("selfHWchk p")

if (%r_tp != 0)
	myhello5<>>>/nil^768&
	while( exist("/pipe/myhello") == FALSE)
	endwhile
	
	****** sorry, English only
	led_ctrl 2 0
	led_ctrl 0 1
	if ( %NS5 )
		echo -r "** FATAL ERROR No.01: Touch Panel is   ">+/pipe/myhello
		echo -r "   not connected: Please contact your  ">+/pipe/myhello
		echo    "   OMRON service center                ">+/pipe/myhello
	else
		echo -r "** FATAL ERROR No.01 : Touch Panel is not    ">+/pipe/myhello
		echo -r "   connected :                               ">+/pipe/myhello
		echo    "   Please contact your OMRON service center  ">+/pipe/myhello
	endif
	mystop
	sleep 0
endif

***** Back light test *****
myhello5 h<>>>/nil^768&
while( exist("/pipe/myhello") == FALSE)
endwhile
sleep 1000
selfHWchk b
echo "!@#$">+/pipe/myhello

***** screen data version check *****
load -d /h0/os9/sys/vercmp
chd /fr1
let ippfile = filematch("*.ipp")
if (len(%ippfile) != 0)
	let vchk = execute(strcat("vercmp 82 ", %ippfile)) 
else
	let vchk = 0
endif
chd /r0

***** selector execute *****
load -d /h0/os9/sys/fonts
load -d /h0/os9/sys/updatemes

if (%vchk == 0)
	if ( %NS5 )
		load -d /h0/os9/sys/selector_q
		let update = execute("selector_q")
	else
		load -d /h0/os9/sys/selector
		let update = execute("selector")
	endif
else
	let update = -1
endif

led_ctrl 2 0
led_Y_blk >>>-/r0/led_temp
let NO = open("/r0/led_temp",READ)
let SIZE = size("/r0/led_temp")
let TEMP = read(%NO,STR,%SIZE)
let PID = mid(%STR,2,%SIZE-1)
let TEMP = close(%NO)

myhello5 ^768<>>>/nil&
while(exist("/pipe/myhello") == FALSE)
endwhile

*******************************
*       start message         *
*******************************
if ( %NS5 )
		echo "[System Update/Recover Program Ver8.2]">+/pipe/myhello
		echo >+/pipe/myhello
else
		echo "  ----------------------------------------   ">+/pipe/myhello
		echo "   System Update/Recover Program  Ver.8.2    ">+/pipe/myhello
		echo "  ----------------------------------------   ">+/pipe/myhello
		echo >+/pipe/myhello
endif

*************************
* Delete files of BANK2 *
*************************
let r_del=execute("del -q /h0/bank2/data/* <>>>/nil")

*** change to UNICODE mode ***
echo "!@#%">+/pipe/myhello

******************************************
* internal memory check and format phase *
******************************************
load -d /h0/os9/sys/sramflag
if (%update == -1)
	echo2 5
	echo2 6 ;* now checking screen data area
	let ret11 = execute("dcheck -r -y /fr1 <>>>/nil")

	***** BKUP Unit Profile Data *****
	***** only NSJ *****
	if (%ptval == 3)
		if (exist("/ro_fr0/etc/UnitProfile.dat") == TRUE)
			let r_copy = execute("copy -ar /ro_fr0/etc/UnitProfile.dat /h0/bank2 <>>>/nil")
			if (%r_copy != 0)
				echo "Fail to back up Unit Profile data">+/pipe/myhello
				sleep 0
			endif
		endif
	endif
	***** BKUP Unit Profile END(NSJ) *****
	
	***** BKUP ROM_CODE Data *****
	***** only v8.1 or later *****
	if (exist("/ro_fr0/sys/ROM_CODE") == TRUE)
		let r_copy = execute("copy -ar /ro_fr0/sys/ROM_CODE /h0/bank2 <>>>/nil")
		if (%r_copy != 0)
			echo "Fail to back up ROM_CODE data">+/pipe/myhello
			sleep 0
		endif
	endif
	***** BKUP ROM_CODE Data END *****

	echo2 7
	echo2 8 ;* now formatting screen data area
	let ret12 = execute("format -r -v= /fr1fmt -np<>>>/nil")
else
	echo2 3
	echo2 4 ;* now making backup copy of setting files
	let r_sflag = execute("sramflag")
	
	if (%r_sflag == 0)
		let ret_bu=execute("copy -ar /ro_fr0/etc/*.ini /h0/bank2/data <>>>/nil")
	elif (exist("/h0/bank2/data/system.ini") == FALSE)
		let ret_bu=execute("copy -ar /ro_fr0/etc/*.ini /h0/bank2/data <>>>/nil")
	else
		let ret_bu=0
	endif

	***** BKUP Unit Profile Data *****
	***** only NSJ *****
	if (%ptval == 3)
		if (exist("/ro_fr0/etc/UnitProfile.dat") == TRUE)
			let r_copy = execute("copy -ar /ro_fr0/etc/UnitProfile.dat /h0/bank2 <>>>/nil")
			if (%r_copy != 0)
				echo "Fail to back up Unit Profile data">+/pipe/myhello
				sleep 0
			endif
		endif
	endif
	***** BKUP Unit Profile END(NSJ) *****
	
	***** BKUP ROM_CODE Data *****
	***** only v8.1 or later *****
	if (exist("/ro_fr0/sys/ROM_CODE") == TRUE)
		let r_copy = execute("copy -ar /ro_fr0/sys/ROM_CODE /h0/bank2 <>>>/nil")
		if (%r_copy != 0)
			echo "Fail to back up ROM_CODE data">+/pipe/myhello
			sleep 0
		endif
	endif
	***** BKUP ROM_CODE Data END *****

	**** sram flag ****
	sramflag 1
	echo2 2
endif

echo2 9
echo2 10; *Now Checking System Program Area
let ret01 = execute("dcheck -r -y /fr0 <>>>/nil")

echo2 11 ;*Now Formatting System Program Area
echo2 12
let ret02 = execute("format -r -v= /fr0fmt -np<>>>/nil")

echo2 13
echo2 14; *Check and Format Phase : END
echo2 2

*************************
* System Download phase *
*************************
echo2 15
echo2 16; *Now System Downloading
****************************************
* copy base system files               *
****************************************
if ( %NS5 )
	**NS5 is detected
	let ret=execute("sysDL3.bat");* use BANK3
else
	**Other NS is detected
	let ret=execute("sysDL.bat");* use BANK1
endif
if (%ret != 0)
	kill %PID
	del -q /r0/led_temp
	led_ctrl 2 0
	led_ctrl 0 2&
	echo2 1
	echo "ERROR">+/pipe/myhello
	sleep 0
endif

makdir /fr0/ETC

load -d /h0/os9/sys/attr
attr -npsnpwnprngsngwngr /fr0/sys <>>>/nil
attr -npsnpwnprngsngwngr /fr0/bin <>>>/nil
attr -npsnpwnprngsngwngr /fr0/font <>>>/nil
attr -npsnpwnprngsngwngr /fr0/other <>>>/nil
attr -npsnpwnprngsngwngr /fr0/run <>>>/nil
attr -npsnpwnprngsngwngr /fr0/fgw <>>>/nil
attr -npsnpwnprngsngwngr /fr0/etcsys <>>>/nil
attr -npsnpwnprngsngwngr /fr0/data <>>>/nil

**********************************************
* remove PDT_VGA.gz files if not NS8 or NS10 *
**********************************************
if ( ! ( %NS8 || %NS10 )  )
	del -q /fr0/run/PDT_VGA.gz
endif

****************************************************
* copy Difference system files NS10/12/15 from NS8 *
****************************************************
if ( %NS15 )
	**NS15-V2 is detected
	****************************************
	* copy XGA system screen and video.ini *
	****************************************
	chd /fr0/run
	copy -ar /h0/os9/xga/* .
	chd /fr0/etcsys
	copy -ar /h0/os9/sys/video.ini_15 ./video.ini
	*********************
	* copy version text *
	*********************
	copy -ar /h0/os9/sys/version_15 /fr0/sys/version
	**************************
	* copy touchpanel driver *
	**************************
	* now, NS15's touchpanel driver is included in the bootfile
	***********************************************************************
	* delete Updated Graphic Driver and TouchPanel Driver (for NS8/10/12) *
	***********************************************************************
	del -q /fr0/bin/tp0
	del -q /fr0/bin/sctouch
	
elif ( %NS12 )
	**NS12-V1/V2 is detected
	****************************************
	* copy SVGA system screen and video.ini*
	****************************************
	chd /fr0/run
	copy -ar /h0/os9/svga/* .
	chd /fr0/etcsys
	copy -ar /h0/os9/sys/video.ini_12 ./video.ini
	*********************
	* copy version text *
	*********************
	copy -ar /h0/os9/sys/version_12 /fr0/sys/version
elif ( %NS10 )
	**NS10-V1/V2 is detected
	*********************
	* copy version text *
	*********************
	copy -ar /h0/os9/sys/version_10 /fr0/sys/version
endif


if( (%NS5) && (%update == -2))
	**** next page ****
	echo2 2
endif

****************************************
* copy Difference system files NS-V2   *
****************************************
let verval = execute("nstype v")

if (%verval == -1)
	**NS-V2 Series detected
	chd /fr0/bin
	if ( %NS5 == FALSE )
		**NS15/12/10/8-V2 Series **
		********************************
		* copy USB driver files for V2 *
		********************************
		copy -ar /h0/os9/v2/bin/ns .
		copy -ar /h0/os9/v2/bin/usbsdrv .
		copy -ar /h0/os9/v2/bin/usb_priority .
		***************************************
		* copy LadderMonitor and Procon files *
		***************************************
		makdir /fr0/TOOL
		makdir /fr0/TOOL/PROCON
		makdir /fr0/TOOL/LDRMT
		attr -npsnpwnprngsngwngr /fr0/tool <>>>/nil
		attr -npsnpwnprngsngwngr /fr0/tool/procon <>>>/nil
		attr -npsnpwnprngsngwngr /fr0/tool/ldrmt <>>>/nil
		chd /fr0/TOOL/ldrmt
		copy -ar /h0/os9/v2/tool/ldrmt/* .
		chd /fr0/sys
		copy -ar /h0/os9/v2/sys/aptextintproglist .
		********************************
		* copy Additional Font File(s) *
		********************************
		chd /fr0/FONT
		copy -ar /h0/os9/v2/font/* .
		**********************
		* copy CIPCore files *
		**********************
		chd /fr0/fgw
		copy -ar /h0/os9/v2/fgw/cipcore.gz .
		*************************
		* copy Web module files *
		*************************
		chd /fr0/sys
		copy -ar /h0/os9/v2/sys/NSWeb.gz .
		copy -ar /h0/os9/v2/sys/omron.gif .
		********************************
		* copy PictBridge module files *
		********************************
		chd /fr0/bin
		copy -ar /h0/os9/v2/bin/sicd .
		copy -ar /h0/os9/v2/bin/sicddrv .
		chd /fr0/sys
		copy -ar /h0/os9/v2/sys/pictprn.gz .
		copy -ar /h0/os9/v2/sys/pbtst.jpg .
		if ( %NS12 )
			**NS12-V2 Series **
			chd /fr0/run
			copy -ar /h0/os9/v2/run/svga/* .
		elif ( (%NS10) || (%NS8) )
			chd /fr0/run
			copy -ar /h0/os9/v2/run/vga/* .
		endif
	else
		**NS5-V2 Series **
		*************************************************
		* copy USB driver files for V2 (same NS12/10/8) *
		*************************************************
		copy -ar /h0/os9/v2/bin/ns .
		copy -ar /h0/os9/v2/bin/usbsdrv .
		copy -ar /h0/os9/v2/bin/usb_priority .
		if ( %NS5x64 == TRUE )
			**NS5-64Mib_RAM **
			***************************************
			* copy LadderMonitor and Procon files *
			***************************************
			makdir /fr0/TOOL
			makdir /fr0/TOOL/PROCON
			makdir /fr0/TOOL/LDRMT
			attr -npsnpwnprngsngwngr /fr0/tool <>>>/nil
			attr -npsnpwnprngsngwngr /fr0/tool/procon <>>>/nil
			attr -npsnpwnprngsngwngr /fr0/tool/ldrmt <>>>/nil
			chd /fr0/TOOL/ldrmt
			copy -ar /h0/os9/v2_ns5x64/tool/ldrmt/* .
			chd /fr0/sys
			copy -ar /h0/os9/v2_ns5x64/sys/aptextintproglist .
			************************************************
			* copy Additional Font File(s)(same NS12/10/8) *
			************************************************
			chd /fr0/FONT
			copy -ar /h0/os9/v2/font/* .
			**************************************
			* copy CIPCore files(same NS12/10/8) *
			**************************************
			chd /fr0/fgw
			copy -ar /h0/os9/v2/fgw/cipcore.gz .
			*************************
			* copy Web module files *
			*************************
			chd /fr0/sys
			copy -ar /h0/os9/v2_ns5x64/sys/NSWeb5.gz .
			copy -ar /h0/os9/v2/sys/omron.gif .
			********************************
			* copy PictBridge module files *
			********************************
			chd /fr0/bin
			copy -ar /h0/os9/v2/bin/sicd .
			copy -ar /h0/os9/v2/bin/sicddrv .
			chd /fr0/sys
			copy -ar /h0/os9/v2_ns5x64/sys/prnunit_ns5.gz .
			copy -ar /h0/os9/v2/sys/pictprn.gz
			copy -ar /h0/os9/v2_ns5x64/sys/nullfm
			copy -ar /h0/os9/v2/sys/pbtst.jpg .
		endif
	endif
endif

****************************************

if (%ptval == 3)
	******************************
	*   NSJ Series is detected   *
	******************************

	if ( %NS5 )
		****************************************
		*   Install additional files for NSJ5  *
		****************************************
*		echo2 31
*		echo2 32; *Now Downloading additional files for NSJ

*		makdir -p /fr0/DATA
		chd /fr0/DATA
		copy -arc=do /h0/OTHER/NSJ/DATA/QVGA/* .
		chd /fr0/ETCSYS
		copy -arc=do /h0/OTHER/NSJ/ETC/* .
		chd /fr0/RUN
		copy -ar /h0/OTHER/NSJ/RUN/QVGA/* .
		chd /fr0/SYS
		copy -ar /h0/OTHER/NSJ/SYS/COMMON/* .
*		copy -ar /h0/OTHER/NSJ/SYS/QVGA/* .
		copy -ar /h0/OTHER/NSJ/SYS/QVGA/startup.bat .
		if ( %NS5x64 )
			copy -ar /h0/OTHER/NSJ/SYS/QVGA/aptextintproglist_NSJ5x64 aptextintproglist
		else
			copy -ar /h0/OTHER/NSJ/SYS/QVGA/aptextintproglist .
		endif
		chd /fr0/fgw
		copy -ar /h0/OTHER/NSJ/FGW/* .
		*** NSWeb is unsupported on NSJ/NSH ***
		chd /fr0/SYS
		del -q /fr0/SYS/NSWeb5.gz
		del -q /fr0/SYS/omron.gif
	elif ( %NS8 )
		****************************************
		*   Install additional files for NSJ8  *
		****************************************
*		echo2 31
*		echo2 32; *Now Downloading additional files for NSJ

*		makdir -p /fr0/DATA
		chd /fr0/DATA
		copy -arc=do /h0/OTHER/NSJ/DATA/VGA/* .
		chd /fr0/ETCSYS
		copy -arc=do /h0/OTHER/NSJ/ETC/* .
		chd /fr0/RUN
		copy -ar /h0/OTHER/NSJ/RUN/VGA/* .
		chd /fr0/SYS
		copy -ar /h0/OTHER/NSJ/SYS/COMMON/* .
		copy -ar /h0/OTHER/NSJ/SYS/VGA/* .
		chd /fr0/fgw
		copy -ar /h0/OTHER/NSJ/FGW/* .
		*** NSWeb is unsupported on NSJ/NSH ***
		chd /fr0/SYS
		del -q /fr0/SYS/NSWeb.gz
		del -q /fr0/SYS/omron.gif
	elif ( %NS10 )
		****************************************
		*   Install additional files for NSJ10 *
		****************************************
*		echo2 31
*		echo2 32; *Now Downloading additional files for NSJ

*		makdir -p /fr0/DATA
		chd /fr0/DATA
		copy -arc=do /h0/OTHER/NSJ/DATA/VGA/* .
		chd /fr0/ETCSYS
		copy -arc=do /h0/OTHER/NSJ/ETC/* .
		chd /fr0/RUN
		copy -ar /h0/OTHER/NSJ/RUN/VGA/* .
		chd /fr0/SYS
		copy -ar /h0/OTHER/NSJ/SYS/COMMON/* .
		copy -ar /h0/OTHER/NSJ/SYS/VGA/* .
		chd /fr0/fgw
		copy -ar /h0/OTHER/NSJ/FGW/* .
		*** NSWeb is unsupported on NSJ/NSH ***
		chd /fr0/SYS
		del -q /fr0/SYS/NSWeb.gz
		del -q /fr0/SYS/omron.gif
	elif ( %NS12 )
		****************************************
		*   Install additional files for NSJ12 *
		****************************************
*		echo2 31
*		echo2 32; *Now Downloading additional files for NSJ

*		makdir -p /fr0/DATA
		chd /fr0/DATA
		copy -arc=do /h0/OTHER/NSJ/DATA/VGA/* .
		chd /fr0/ETCSYS
		copy -arc=do /h0/OTHER/NSJ/ETC/* .
		chd /fr0/SYS
		copy -ar /h0/OTHER/NSJ/SYS/COMMON/* .
		copy -ar /h0/OTHER/NSJ/SYS/VGA/* .
		chd /fr0/fgw
		copy -ar /h0/OTHER/NSJ/FGW/* .
		chd /fr0/RUN
		copy -ar /h0/OTHER/NSJ/RUN/SVGA/* .
		*** NSWeb is unsupported on NSJ/NSH ***
		chd /fr0/SYS
		del -q /fr0/SYS/NSWeb.gz
		del -q /fr0/SYS/omron.gif
	endif
elif (%ptval == 2)
	**************************************
	*   Install additional files for NSH *
	**************************************
*	echo2 33
*	echo2 34; *Now Downloading additional files for NSH

	chd /fr0/ETCSYS
	copy -arc=do /h0/OTHER/NSH/ETC/* .
	chd /fr0/FGW
	copy -ar /h0/OTHER/NSH/FGW/* .
	chd /fr0/RUN
	copy -ar /h0/OTHER/NSH/RUN/QVGA/* .
	chd /fr0/SYS
	copy -ar /h0/OTHER/NSH/SYS/* .
	chd /fr0/BIN
	copy -ar /h0/OTHER/NSH/BIN/* .
*	del -q /fr0/BIN/USB_Priority
	*** NSWeb is unsupported on NSJ/NSH ***
	chd /fr0/SYS
	del -q /fr0/SYS/NSWeb5.gz
	del -q /fr0/SYS/omron.gif
endif

copy /ro_fr0/ETCSYS/* /fr0/ETC

echo2 17
echo2 18; *System Download Phase : END

load -d /h0/os9/sys/pflash

if ( %NS15 )
	**NS15-V2 is detected
	*******************
	* OS installation *
	*******************
	echo2 19
	echo2 20; *Now Updating Operating System
*	load -d /h0/os9/sys/rdm_image1_15
	gzload /h0/os9/sys/rdm_image1_15.gz <>>>/nil
	let ret = execute("pflash -b<>>>/nil")
	if (%ret == 0)
		echo2 2; echo2 2
		if (%update == -2)
			echo2 2
		endif
	endif

elif ( %NS12 )
	**NS12-V1 is detected
	*******************
	* OS installation *
	*******************
	echo2 19
	echo2 20; *Now Updating Operating System
*	load -d /h0/os9/sys/rdm_image1_12
	gzload /h0/os9/sys/rdm_image1_12.gz<>>>/nil
	let ret = execute("pflash -b<>>>/nil")
	if (%ret == 0)
		echo2 2; echo2 2
		if (%update == -2)
			echo2 2
		endif
	endif

elif ( %NS10 )
	**NS10-V1 is detected
	*******************
	* OS installation *
	*******************
	echo2 19
	echo2 20; *Now Updating Operating System
*	load -d /h0/os9/sys/rdm_image1_10
	gzload /h0/os9/sys/rdm_image1_10.gz <>>>/nil
	let ret = execute("pflash -b<>>>/nil")
	if (%ret == 0)
		echo2 2; echo2 2
		if (%update == -2)
			echo2 2
		endif
	endif
	
elif ( %NS8 )
	**NS8-V1 is detected
	*******************
	* OS installation *
	*******************
	echo2 19
	echo2 20; *Now Updating Operating System
*	load -d /h0/os9/sys/rdm_image1_8
	gzload /h0/os9/sys/rdm_image1_8.gz <>>>/nil
	let ret = execute("pflash -b<>>>/nil")
	if (%ret == 0)
		echo2 2; echo2 2
		if (%update == -2)
			echo2 2
		endif
	endif

elif ( %NS5 )
	**NS5 is detected
	*******************
	* OS installation *
	*******************
	echo2 19
	echo2 20; *Now Updating Operating System
	if ( %NS5x32 )
*		load -d /h0/os9/sys/rdm_image1_5
		gzload /h0/os9/sys/rdm_image1_5.gz <>>>/nil
	else
*		load -d /h0/os9/sys/rdm_image2_5
		gzload /h0/os9/sys/rdm_image2_5.gz <>>>/nil
	endif
	let ret = execute("pflash -b<>>>/nil")
endif

******** error procedure *******
if (%ret != 0)
	kill %PID
	del -q /r0/led_temp
	led_ctrl 2 0
	led_ctrl 0 2&
	echo2 1
	echo "ERROR">+/pipe/myhello
	sleep 0
endif

echo2 21
echo2 22 ;* OS Update Phase : END

load -d /h0/os9/sys/MagicNo
if (%update == -1)
	***************************
	*Write SRAM magicNO phase *
	***************************
	MagicNo
	echo2 25 ;*Log Data Clear Phase : END
	echo2 26
	echo2 2
else
	*********************
	* Restore ini files *
	*********************
	MagicNo u ;** user_id area clear or not
	echo2 23
	echo2 24
	echo2 2
	if (%ret_bu == 0)
		let ret_bu=execute("copy -ar /h0/bank2/data/*.ini /r0 <>>>/nil")
		let ret_bu=execute("copy -ar /r0/*.ini /fr0/etc <>>>/nil")
	endif
endif

***** Restore Unit Profile Data *****
***** only NSJ *****
if (%ptval == 3)
	if (exist("/h0/bank2/UnitProfile.dat") == TRUE)
		let r_copy = execute("copy -ar /h0/bank2/UnitProfile.dat /fr0/etc <>>>/nil")
		if (%r_copy != 0)
			echo "Fail to back up Unit Profile data">+/pipe/myhello
			sleep 0
		endif
		do execute("del -q /h0/bank2/UnitProfile.dat <>>>/nil")
	endif
endif
***** BKUP Unit Profile END(NSJ) *****

***** Restore ROM_CODE Data *****
***** only v8.1 or later *****
if (exist("/h0/bank2/ROM_CODE") == TRUE)
	let r_copy = execute("copy -ar /h0/bank2/ROM_CODE /fr0/sys <>>>/nil")
	if (%r_copy != 0)
		echo "Fail to back up ROM_CODE data">+/pipe/myhello
		sleep 0
	endif
	do execute("del -q /h0/bank2/ROM_CODE <>>>/nil")
endif
***** Restore ROM_CODE Data END *****

sramflag 0

let r_del = execute("del -q /h0/bank2/data/* <>>>/nil")
load -d /h0/os9/sys/CFdetach
let r_cfdetach = execute("CFdetach")

echo2 27; *Complete System and OS downloading
echo2 28; *Please switch OFF.
echo2 29
echo2 30

kill %PID
del -q /r0/led_temp
led_ctrl 2 0
led_ctrl 1 2&

sleep 0
